import { ReactNode } from 'react';
import { SignalIndicator, Options } from '../../services/WebSocket/typedef';
import { SignalListener } from '../../services/SignalListeners/typedef';
export declare type WebSocketOptions<Req, Res, Err, SReq = Req, DRes = Res> = Options<Req, Res, Err, SReq, DRes> & {
    getRequestSignalIndicator: GetReqSignalIndicator<Req>;
    autoConnect?: boolean;
};
export declare type ProviderProps<Req, Res, Err = string, SReq = Req, DRes = Res> = {
    options: WebSocketOptions<Req, Res, Err, SReq, DRes>;
    children: ReactNode | ReactNode[];
};
declare type GetReqSignalIndicator<Req> = (req: Req) => SignalIndicator;
export declare type Context<Req = any, DRes = any, Err = any> = {
    connected: boolean;
    open: () => void;
    send: (data: any) => void;
    close: () => void;
    addSignalListener: (signal: SignalIndicator, listener: SignalListener<DRes, Err>) => () => void;
    removeSignalListener: (signal: SignalIndicator, id: string) => void;
    getRequestSignalIndicator: GetReqSignalIndicator<Req>;
};
export {};
